# coding: utf-8

# flake8: noqa
"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import models into model package
from sigfox_api_client.models.action_job import ActionJob
from sigfox_api_client.models.antenna import Antenna
from sigfox_api_client.models.api_user import ApiUser
from sigfox_api_client.models.api_user_creation import ApiUserCreation
from sigfox_api_client.models.api_user_edition import ApiUserEdition
from sigfox_api_client.models.asynchronous_device_creation_job import AsynchronousDeviceCreationJob
from sigfox_api_client.models.asynchronous_device_edition_job import AsynchronousDeviceEditionJob
from sigfox_api_client.models.asynchronous_device_replacement_job import AsynchronousDeviceReplacementJob
from sigfox_api_client.models.asynchronous_device_transfer_job import AsynchronousDeviceTransferJob
from sigfox_api_client.models.base_contact import BaseContact
from sigfox_api_client.models.base_convention import BaseConvention
from sigfox_api_client.models.base_device_type import BaseDeviceType
from sigfox_api_client.models.base_geolocation import BaseGeolocation
from sigfox_api_client.models.base_host import BaseHost
from sigfox_api_client.models.base_intervention import BaseIntervention
from sigfox_api_client.models.base_maintenance import BaseMaintenance
from sigfox_api_client.models.base_provider import BaseProvider
from sigfox_api_client.models.base_response import BaseResponse
from sigfox_api_client.models.base_site import BaseSite
from sigfox_api_client.models.base_station import BaseStation
from sigfox_api_client.models.basic import Basic
from sigfox_api_client.models.basic_create import BasicCreate
from sigfox_api_client.models.basic_update import BasicUpdate
from sigfox_api_client.models.batch_url_callback import BatchUrlCallback
from sigfox_api_client.models.billable_group import BillableGroup
from sigfox_api_client.models.bounds import Bounds
from sigfox_api_client.models.bulk_device_asynchronous_request import BulkDeviceAsynchronousRequest
from sigfox_api_client.models.bulk_unsubscribe import BulkUnsubscribe
from sigfox_api_client.models.callback import Callback
from sigfox_api_client.models.callback_email import CallbackEmail
from sigfox_api_client.models.callback_http import CallbackHTTP
from sigfox_api_client.models.callback_medium import CallbackMedium
from sigfox_api_client.models.cb_status import CbStatus
from sigfox_api_client.models.cellular_connectivity_base import CellularConnectivityBase
from sigfox_api_client.models.cellular_connectivity_for_bs import CellularConnectivityForBs
from sigfox_api_client.models.cellular_connectivity_for_group import CellularConnectivityForGroup
from sigfox_api_client.models.cellular_connectivity_update import CellularConnectivityUpdate
from sigfox_api_client.models.certificate import Certificate
from sigfox_api_client.models.certificate_update import CertificateUpdate
from sigfox_api_client.models.channel import Channel
from sigfox_api_client.models.channel_create import ChannelCreate
from sigfox_api_client.models.channel_update import ChannelUpdate
from sigfox_api_client.models.common_api_user import CommonApiUser
from sigfox_api_client.models.common_certificate import CommonCertificate
from sigfox_api_client.models.common_contract_info import CommonContractInfo
from sigfox_api_client.models.common_device import CommonDevice
from sigfox_api_client.models.common_group_create import CommonGroupCreate
from sigfox_api_client.models.common_group_update import CommonGroupUpdate
from sigfox_api_client.models.common_role import CommonRole
from sigfox_api_client.models.common_user import CommonUser
from sigfox_api_client.models.computed_location import ComputedLocation
from sigfox_api_client.models.contact import Contact
from sigfox_api_client.models.contract_id import ContractId
from sigfox_api_client.models.contract_info import ContractInfo
from sigfox_api_client.models.contract_info_create import ContractInfoCreate
from sigfox_api_client.models.contract_info_update import ContractInfoUpdate
from sigfox_api_client.models.convention import Convention
from sigfox_api_client.models.create_batch_url_callback import CreateBatchUrlCallback
from sigfox_api_client.models.create_callback import CreateCallback
from sigfox_api_client.models.create_email_callback import CreateEmailCallback
from sigfox_api_client.models.create_response import CreateResponse
from sigfox_api_client.models.create_url_callback import CreateUrlCallback
from sigfox_api_client.models.dist import DIST
from sigfox_api_client.models.dist_create import DISTCreate
from sigfox_api_client.models.dist_update import DISTUpdate
from sigfox_api_client.models.device import Device
from sigfox_api_client.models.device_action_job import DeviceActionJob
from sigfox_api_client.models.device_consumption import DeviceConsumption
from sigfox_api_client.models.device_creation_job import DeviceCreationJob
from sigfox_api_client.models.device_edition_bulk import DeviceEditionBulk
from sigfox_api_client.models.device_location import DeviceLocation
from sigfox_api_client.models.device_message import DeviceMessage
from sigfox_api_client.models.device_type import DeviceType
from sigfox_api_client.models.device_type_create import DeviceTypeCreate
from sigfox_api_client.models.device_type_update import DeviceTypeUpdate
from sigfox_api_client.models.device_update_job import DeviceUpdateJob
from sigfox_api_client.models.downlink_answer_status import DownlinkAnswerStatus
from sigfox_api_client.models.email_callback import EmailCallback
from sigfox_api_client.models.error_content import ErrorContent
from sigfox_api_client.models.error_messages import ErrorMessages
from sigfox_api_client.models.ethernet_connectivity_base import EthernetConnectivityBase
from sigfox_api_client.models.ethernet_connectivity_for_bs import EthernetConnectivityForBs
from sigfox_api_client.models.ethernet_connectivity_for_group import EthernetConnectivityForGroup
from sigfox_api_client.models.ethernet_connectivity_update import EthernetConnectivityUpdate
from sigfox_api_client.models.geoloc_payload_config import GeolocPayloadConfig
from sigfox_api_client.models.global_coverage_request import GlobalCoverageRequest
from sigfox_api_client.models.global_coverage_response import GlobalCoverageResponse
from sigfox_api_client.models.group import Group
from sigfox_api_client.models.host import Host
from sigfox_api_client.models.host_creation import HostCreation
from sigfox_api_client.models.internet_subscription import InternetSubscription
from sigfox_api_client.models.intervention import Intervention
from sigfox_api_client.models.job_error import JobError
from sigfox_api_client.models.kmz_create_public_request import KmzCreatePublicRequest
from sigfox_api_client.models.kmz_status_response import KmzStatusResponse
from sigfox_api_client.models.lat_lng import LatLng
from sigfox_api_client.models.location import Location
from sigfox_api_client.models.location_with_status import LocationWithStatus
from sigfox_api_client.models.maintenance import Maintenance
from sigfox_api_client.models.min_base_station import MinBaseStation
from sigfox_api_client.models.min_contact import MinContact
from sigfox_api_client.models.min_contract_info import MinContractInfo
from sigfox_api_client.models.min_device_type import MinDeviceType
from sigfox_api_client.models.min_group import MinGroup
from sigfox_api_client.models.min_host import MinHost
from sigfox_api_client.models.min_hw_family import MinHwFamily
from sigfox_api_client.models.min_maintenance import MinMaintenance
from sigfox_api_client.models.min_meta_role import MinMetaRole
from sigfox_api_client.models.min_perm import MinPerm
from sigfox_api_client.models.min_profile import MinProfile
from sigfox_api_client.models.min_provider import MinProvider
from sigfox_api_client.models.min_role import MinRole
from sigfox_api_client.models.min_site import MinSite
from sigfox_api_client.models.modem_certificate import ModemCertificate
from sigfox_api_client.models.modem_certificate_radio_configuration import ModemCertificateRadioConfiguration
from sigfox_api_client.models.nip import NIP
from sigfox_api_client.models.nip_create import NIPCreate
from sigfox_api_client.models.nip_update import NIPUpdate
from sigfox_api_client.models.paging import Paging
from sigfox_api_client.models.partner import Partner
from sigfox_api_client.models.partner_create import PartnerCreate
from sigfox_api_client.models.partner_update import PartnerUpdate
from sigfox_api_client.models.partners import Partners
from sigfox_api_client.models.partners_create import PartnersCreate
from sigfox_api_client.models.partners_update import PartnersUpdate
from sigfox_api_client.models.product_certificate import ProductCertificate
from sigfox_api_client.models.product_certificate_radio_configuration import ProductCertificateRadioConfiguration
from sigfox_api_client.models.product_certificate_with_pac_response import ProductCertificateWithPacResponse
from sigfox_api_client.models.profile import Profile
from sigfox_api_client.models.profile_ids import ProfileIds
from sigfox_api_client.models.provider import Provider
from sigfox_api_client.models.provider_creation import ProviderCreation
from sigfox_api_client.models.radio_certificate import RadioCertificate
from sigfox_api_client.models.radio_configuration import RadioConfiguration
from sigfox_api_client.models.redundancy_response import RedundancyResponse
from sigfox_api_client.models.registration_job import RegistrationJob
from sigfox_api_client.models.registration_job_status import RegistrationJobStatus
from sigfox_api_client.models.replace_response import ReplaceResponse
from sigfox_api_client.models.rinfo import Rinfo
from sigfox_api_client.models.role import Role
from sigfox_api_client.models.role_create import RoleCreate
from sigfox_api_client.models.so import SO
from sigfox_api_client.models.so_create import SOCreate
from sigfox_api_client.models.so_update import SOUpdate
from sigfox_api_client.models.svno import SVNO
from sigfox_api_client.models.svno_create import SVNOCreate
from sigfox_api_client.models.svno_update import SVNOUpdate
from sigfox_api_client.models.single_device_fields import SingleDeviceFields
from sigfox_api_client.models.site import Site
from sigfox_api_client.models.sites import Sites
from sigfox_api_client.models.starter import Starter
from sigfox_api_client.models.starter_create import StarterCreate
from sigfox_api_client.models.starter_update import StarterUpdate
from sigfox_api_client.models.tiles_response import TilesResponse
from sigfox_api_client.models.token import Token
from sigfox_api_client.models.token_unsubscribe import TokenUnsubscribe
from sigfox_api_client.models.update_callback import UpdateCallback
from sigfox_api_client.models.update_email_callback import UpdateEmailCallback
from sigfox_api_client.models.update_response import UpdateResponse
from sigfox_api_client.models.update_url_callback import UpdateUrlCallback
from sigfox_api_client.models.updatebatch_url_callback import UpdatebatchUrlCallback
from sigfox_api_client.models.url_callback import UrlCallback
from sigfox_api_client.models.user import User
from sigfox_api_client.models.user_creation import UserCreation
from sigfox_api_client.models.user_role import UserRole
from sigfox_api_client.models.user_update import UserUpdate
