# coding: utf-8

"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class BaseConvention(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'annual_cost': 'float',
        'comments': 'str',
        'start_time': 'int',
        'end_time': 'int',
        'contract_reference': 'str',
        'maintenance': 'bool',
        'maintenance_annual_cost': 'float',
        'status': 'int',
        'type': 'int'
    }

    attribute_map = {
        'annual_cost': 'annualCost',
        'comments': 'comments',
        'start_time': 'startTime',
        'end_time': 'endTime',
        'contract_reference': 'contractReference',
        'maintenance': 'maintenance',
        'maintenance_annual_cost': 'maintenanceAnnualCost',
        'status': 'status',
        'type': 'type'
    }

    def __init__(self, annual_cost=None, comments=None, start_time=None, end_time=None, contract_reference=None, maintenance=None, maintenance_annual_cost=None, status=None, type=None):  # noqa: E501
        """BaseConvention - a model defined in Swagger"""  # noqa: E501
        self._annual_cost = None
        self._comments = None
        self._start_time = None
        self._end_time = None
        self._contract_reference = None
        self._maintenance = None
        self._maintenance_annual_cost = None
        self._status = None
        self._type = None
        self.discriminator = None
        if annual_cost is not None:
            self.annual_cost = annual_cost
        if comments is not None:
            self.comments = comments
        if start_time is not None:
            self.start_time = start_time
        if end_time is not None:
            self.end_time = end_time
        if contract_reference is not None:
            self.contract_reference = contract_reference
        if maintenance is not None:
            self.maintenance = maintenance
        if maintenance_annual_cost is not None:
            self.maintenance_annual_cost = maintenance_annual_cost
        if status is not None:
            self.status = status
        if type is not None:
            self.type = type

    @property
    def annual_cost(self):
        """Gets the annual_cost of this BaseConvention.  # noqa: E501

        The annual cost of this convention  # noqa: E501

        :return: The annual_cost of this BaseConvention.  # noqa: E501
        :rtype: float
        """
        return self._annual_cost

    @annual_cost.setter
    def annual_cost(self, annual_cost):
        """Sets the annual_cost of this BaseConvention.

        The annual cost of this convention  # noqa: E501

        :param annual_cost: The annual_cost of this BaseConvention.  # noqa: E501
        :type: float
        """

        self._annual_cost = annual_cost

    @property
    def comments(self):
        """Gets the comments of this BaseConvention.  # noqa: E501

        The comments of this convention  # noqa: E501

        :return: The comments of this BaseConvention.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this BaseConvention.

        The comments of this convention  # noqa: E501

        :param comments: The comments of this BaseConvention.  # noqa: E501
        :type: str
        """

        self._comments = comments

    @property
    def start_time(self):
        """Gets the start_time of this BaseConvention.  # noqa: E501

        The start time of this convention  # noqa: E501

        :return: The start_time of this BaseConvention.  # noqa: E501
        :rtype: int
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this BaseConvention.

        The start time of this convention  # noqa: E501

        :param start_time: The start_time of this BaseConvention.  # noqa: E501
        :type: int
        """

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this BaseConvention.  # noqa: E501

        The end time of this convention  # noqa: E501

        :return: The end_time of this BaseConvention.  # noqa: E501
        :rtype: int
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this BaseConvention.

        The end time of this convention  # noqa: E501

        :param end_time: The end_time of this BaseConvention.  # noqa: E501
        :type: int
        """

        self._end_time = end_time

    @property
    def contract_reference(self):
        """Gets the contract_reference of this BaseConvention.  # noqa: E501

        The bss contract reference of this convention  # noqa: E501

        :return: The contract_reference of this BaseConvention.  # noqa: E501
        :rtype: str
        """
        return self._contract_reference

    @contract_reference.setter
    def contract_reference(self, contract_reference):
        """Sets the contract_reference of this BaseConvention.

        The bss contract reference of this convention  # noqa: E501

        :param contract_reference: The contract_reference of this BaseConvention.  # noqa: E501
        :type: str
        """

        self._contract_reference = contract_reference

    @property
    def maintenance(self):
        """Gets the maintenance of this BaseConvention.  # noqa: E501

        is this convention in maintenance  # noqa: E501

        :return: The maintenance of this BaseConvention.  # noqa: E501
        :rtype: bool
        """
        return self._maintenance

    @maintenance.setter
    def maintenance(self, maintenance):
        """Sets the maintenance of this BaseConvention.

        is this convention in maintenance  # noqa: E501

        :param maintenance: The maintenance of this BaseConvention.  # noqa: E501
        :type: bool
        """

        self._maintenance = maintenance

    @property
    def maintenance_annual_cost(self):
        """Gets the maintenance_annual_cost of this BaseConvention.  # noqa: E501

        The annual cost of the maintenance of this convention  # noqa: E501

        :return: The maintenance_annual_cost of this BaseConvention.  # noqa: E501
        :rtype: float
        """
        return self._maintenance_annual_cost

    @maintenance_annual_cost.setter
    def maintenance_annual_cost(self, maintenance_annual_cost):
        """Sets the maintenance_annual_cost of this BaseConvention.

        The annual cost of the maintenance of this convention  # noqa: E501

        :param maintenance_annual_cost: The maintenance_annual_cost of this BaseConvention.  # noqa: E501
        :type: float
        """

        self._maintenance_annual_cost = maintenance_annual_cost

    @property
    def status(self):
        """Gets the status of this BaseConvention.  # noqa: E501

        Convention status. - 0 -> AT SIGFOX - 1 -> AT HOST - 2 -> SIGNED SIGFOX - 3 -> SIGNED HOST - 4 -> SIGNED BOTH   # noqa: E501

        :return: The status of this BaseConvention.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this BaseConvention.

        Convention status. - 0 -> AT SIGFOX - 1 -> AT HOST - 2 -> SIGNED SIGFOX - 3 -> SIGNED HOST - 4 -> SIGNED BOTH   # noqa: E501

        :param status: The status of this BaseConvention.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def type(self):
        """Gets the type of this BaseConvention.  # noqa: E501

        Convention status. - 0 -> CONDOMINIUM - 1 -> INDIVIDUAL - 2 -> SOCIAL HOUSING AUTHORITY - 3 -> ASSOCIATION - 4 -> COMPANY   # noqa: E501

        :return: The type of this BaseConvention.  # noqa: E501
        :rtype: int
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this BaseConvention.

        Convention status. - 0 -> CONDOMINIUM - 1 -> INDIVIDUAL - 2 -> SOCIAL HOUSING AUTHORITY - 3 -> ASSOCIATION - 4 -> COMPANY   # noqa: E501

        :param type: The type of this BaseConvention.  # noqa: E501
        :type: int
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BaseConvention, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BaseConvention):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
