# coding: utf-8

"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class BaseSite(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'lessor_id': 'str',
        'address': 'str',
        'comment': 'str',
        'status': 'int',
        'status_comment': 'str',
        'station_installation': 'int',
        'inverter_info': 'int',
        'aerial_work_platform_access': 'bool',
        'lat': 'float',
        'lng': 'float'
    }

    attribute_map = {
        'name': 'name',
        'lessor_id': 'lessorId',
        'address': 'address',
        'comment': 'comment',
        'status': 'status',
        'status_comment': 'statusComment',
        'station_installation': 'stationInstallation',
        'inverter_info': 'inverterInfo',
        'aerial_work_platform_access': 'aerialWorkPlatformAccess',
        'lat': 'lat',
        'lng': 'lng'
    }

    def __init__(self, name=None, lessor_id=None, address=None, comment=None, status=None, status_comment=None, station_installation=None, inverter_info=None, aerial_work_platform_access=None, lat=None, lng=None):  # noqa: E501
        """BaseSite - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._lessor_id = None
        self._address = None
        self._comment = None
        self._status = None
        self._status_comment = None
        self._station_installation = None
        self._inverter_info = None
        self._aerial_work_platform_access = None
        self._lat = None
        self._lng = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if lessor_id is not None:
            self.lessor_id = lessor_id
        if address is not None:
            self.address = address
        if comment is not None:
            self.comment = comment
        if status is not None:
            self.status = status
        if status_comment is not None:
            self.status_comment = status_comment
        if station_installation is not None:
            self.station_installation = station_installation
        if inverter_info is not None:
            self.inverter_info = inverter_info
        if aerial_work_platform_access is not None:
            self.aerial_work_platform_access = aerial_work_platform_access
        if lat is not None:
            self.lat = lat
        if lng is not None:
            self.lng = lng

    @property
    def name(self):
        """Gets the name of this BaseSite.  # noqa: E501

        The site's name  # noqa: E501

        :return: The name of this BaseSite.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BaseSite.

        The site's name  # noqa: E501

        :param name: The name of this BaseSite.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def lessor_id(self):
        """Gets the lessor_id of this BaseSite.  # noqa: E501

        The lessor identifier of the site. This field can be unset when updating.  # noqa: E501

        :return: The lessor_id of this BaseSite.  # noqa: E501
        :rtype: str
        """
        return self._lessor_id

    @lessor_id.setter
    def lessor_id(self, lessor_id):
        """Sets the lessor_id of this BaseSite.

        The lessor identifier of the site. This field can be unset when updating.  # noqa: E501

        :param lessor_id: The lessor_id of this BaseSite.  # noqa: E501
        :type: str
        """

        self._lessor_id = lessor_id

    @property
    def address(self):
        """Gets the address of this BaseSite.  # noqa: E501

        The address of the site  # noqa: E501

        :return: The address of this BaseSite.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this BaseSite.

        The address of the site  # noqa: E501

        :param address: The address of this BaseSite.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def comment(self):
        """Gets the comment of this BaseSite.  # noqa: E501

        Comment about the site. This field can be unset when updating.  # noqa: E501

        :return: The comment of this BaseSite.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this BaseSite.

        Comment about the site. This field can be unset when updating.  # noqa: E501

        :param comment: The comment of this BaseSite.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def status(self):
        """Gets the status of this BaseSite.  # noqa: E501

        Site status: - 0 -> PROD - 1 -> REFUSED - 2 -> INSTALLED - 3 -> NOT PLANNED - 4 -> PRE PROD - 5 -> CANDIDATE - 6 -> CANCELLED - 7 -> CLIENT - 8 -> RD - 9 -> LABO - 14 -> INSTALLED CONNECTED ONLY SECONDARY - 15 -> INSTALLED CONNECTED ONLY PRIMARY   # noqa: E501

        :return: The status of this BaseSite.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this BaseSite.

        Site status: - 0 -> PROD - 1 -> REFUSED - 2 -> INSTALLED - 3 -> NOT PLANNED - 4 -> PRE PROD - 5 -> CANDIDATE - 6 -> CANCELLED - 7 -> CLIENT - 8 -> RD - 9 -> LABO - 14 -> INSTALLED CONNECTED ONLY SECONDARY - 15 -> INSTALLED CONNECTED ONLY PRIMARY   # noqa: E501

        :param status: The status of this BaseSite.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def status_comment(self):
        """Gets the status_comment of this BaseSite.  # noqa: E501

        The comment of the status of the site. This field can be unset when updating.  # noqa: E501

        :return: The status_comment of this BaseSite.  # noqa: E501
        :rtype: str
        """
        return self._status_comment

    @status_comment.setter
    def status_comment(self, status_comment):
        """Sets the status_comment of this BaseSite.

        The comment of the status of the site. This field can be unset when updating.  # noqa: E501

        :param status_comment: The status_comment of this BaseSite.  # noqa: E501
        :type: str
        """

        self._status_comment = status_comment

    @property
    def station_installation(self):
        """Gets the station_installation of this BaseSite.  # noqa: E501

        Station installation: - 0 -> INDOOR WITHOUT CABINET - 1 -> INDOOR WITH CABINET - 2 -> OUTDOOR WITHOUT CABINET - 3 -> OUTDOOR WITH CABINET   # noqa: E501

        :return: The station_installation of this BaseSite.  # noqa: E501
        :rtype: int
        """
        return self._station_installation

    @station_installation.setter
    def station_installation(self, station_installation):
        """Sets the station_installation of this BaseSite.

        Station installation: - 0 -> INDOOR WITHOUT CABINET - 1 -> INDOOR WITH CABINET - 2 -> OUTDOOR WITHOUT CABINET - 3 -> OUTDOOR WITH CABINET   # noqa: E501

        :param station_installation: The station_installation of this BaseSite.  # noqa: E501
        :type: int
        """

        self._station_installation = station_installation

    @property
    def inverter_info(self):
        """Gets the inverter_info of this BaseSite.  # noqa: E501

        Inverter type: - 0 -> NONE - 1 -> AC POWER HOST - 2 -> AC POWER HOST INVERTER - 3 -> AC POWER SIGFOX INVERTER - 4 -> DC POWER HOST 48V - 5 -> DC POWER SOLAR   # noqa: E501

        :return: The inverter_info of this BaseSite.  # noqa: E501
        :rtype: int
        """
        return self._inverter_info

    @inverter_info.setter
    def inverter_info(self, inverter_info):
        """Sets the inverter_info of this BaseSite.

        Inverter type: - 0 -> NONE - 1 -> AC POWER HOST - 2 -> AC POWER HOST INVERTER - 3 -> AC POWER SIGFOX INVERTER - 4 -> DC POWER HOST 48V - 5 -> DC POWER SOLAR   # noqa: E501

        :param inverter_info: The inverter_info of this BaseSite.  # noqa: E501
        :type: int
        """

        self._inverter_info = inverter_info

    @property
    def aerial_work_platform_access(self):
        """Gets the aerial_work_platform_access of this BaseSite.  # noqa: E501

        is the site access to the aerial work platform  # noqa: E501

        :return: The aerial_work_platform_access of this BaseSite.  # noqa: E501
        :rtype: bool
        """
        return self._aerial_work_platform_access

    @aerial_work_platform_access.setter
    def aerial_work_platform_access(self, aerial_work_platform_access):
        """Sets the aerial_work_platform_access of this BaseSite.

        is the site access to the aerial work platform  # noqa: E501

        :param aerial_work_platform_access: The aerial_work_platform_access of this BaseSite.  # noqa: E501
        :type: bool
        """

        self._aerial_work_platform_access = aerial_work_platform_access

    @property
    def lat(self):
        """Gets the lat of this BaseSite.  # noqa: E501

        the site's latitude  # noqa: E501

        :return: The lat of this BaseSite.  # noqa: E501
        :rtype: float
        """
        return self._lat

    @lat.setter
    def lat(self, lat):
        """Sets the lat of this BaseSite.

        the site's latitude  # noqa: E501

        :param lat: The lat of this BaseSite.  # noqa: E501
        :type: float
        """

        self._lat = lat

    @property
    def lng(self):
        """Gets the lng of this BaseSite.  # noqa: E501

        the site's longitutde  # noqa: E501

        :return: The lng of this BaseSite.  # noqa: E501
        :rtype: float
        """
        return self._lng

    @lng.setter
    def lng(self, lng):
        """Sets the lng of this BaseSite.

        the site's longitutde  # noqa: E501

        :param lng: The lng of this BaseSite.  # noqa: E501
        :type: float
        """

        self._lng = lng

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BaseSite, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BaseSite):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
