# coding: utf-8

"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from sigfox_api_client.models.cellular_connectivity_base import CellularConnectivityBase


class CellularConnectivityForBs(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'group': 'MinGroup',
        'base_station': 'MinBaseStation',
        'state': 'int',
        'sync_status': 'int',
        'last_switch_error_status': 'int',
        'last_setconf_error_status': 'int'
    }
    if hasattr(CellularConnectivityBase, "swagger_types"):
        swagger_types.update(CellularConnectivityBase.swagger_types)

    attribute_map = {
        'id': 'id',
        'group': 'group',
        'base_station': 'baseStation',
        'state': 'state',
        'sync_status': 'syncStatus',
        'last_switch_error_status': 'lastSwitchErrorStatus',
        'last_setconf_error_status': 'lastSetconfErrorStatus'
    }
    if hasattr(CellularConnectivityBase, "attribute_map"):
        attribute_map.update(CellularConnectivityBase.attribute_map)

    def __init__(self, id=None, group=None, base_station=None, state=None, sync_status=None, last_switch_error_status=None, last_setconf_error_status=None, *args, **kwargs):  # noqa: E501
        """CellularConnectivityForBs - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._group = None
        self._base_station = None
        self._state = None
        self._sync_status = None
        self._last_switch_error_status = None
        self._last_setconf_error_status = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if group is not None:
            self.group = group
        if base_station is not None:
            self.base_station = base_station
        if state is not None:
            self.state = state
        if sync_status is not None:
            self.sync_status = sync_status
        if last_switch_error_status is not None:
            self.last_switch_error_status = last_switch_error_status
        if last_setconf_error_status is not None:
            self.last_setconf_error_status = last_setconf_error_status
        CellularConnectivityBase.__init__(self, *args, **kwargs)

    @property
    def id(self):
        """Gets the id of this CellularConnectivityForBs.  # noqa: E501

        The group's identifier  # noqa: E501

        :return: The id of this CellularConnectivityForBs.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CellularConnectivityForBs.

        The group's identifier  # noqa: E501

        :param id: The id of this CellularConnectivityForBs.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def group(self):
        """Gets the group of this CellularConnectivityForBs.  # noqa: E501


        :return: The group of this CellularConnectivityForBs.  # noqa: E501
        :rtype: MinGroup
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this CellularConnectivityForBs.


        :param group: The group of this CellularConnectivityForBs.  # noqa: E501
        :type: MinGroup
        """

        self._group = group

    @property
    def base_station(self):
        """Gets the base_station of this CellularConnectivityForBs.  # noqa: E501


        :return: The base_station of this CellularConnectivityForBs.  # noqa: E501
        :rtype: MinBaseStation
        """
        return self._base_station

    @base_station.setter
    def base_station(self, base_station):
        """Sets the base_station of this CellularConnectivityForBs.


        :param base_station: The base_station of this CellularConnectivityForBs.  # noqa: E501
        :type: MinBaseStation
        """

        self._base_station = base_station

    @property
    def state(self):
        """Gets the state of this CellularConnectivityForBs.  # noqa: E501

        State of a cellular connectivity configuration 0 -> ACTIVE 1 -> PASSIVE 2 -> PENDING (new configuration to synchronize with the base station) 3 -> REJECTED 4 -> DELETING   # noqa: E501

        :return: The state of this CellularConnectivityForBs.  # noqa: E501
        :rtype: int
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this CellularConnectivityForBs.

        State of a cellular connectivity configuration 0 -> ACTIVE 1 -> PASSIVE 2 -> PENDING (new configuration to synchronize with the base station) 3 -> REJECTED 4 -> DELETING   # noqa: E501

        :param state: The state of this CellularConnectivityForBs.  # noqa: E501
        :type: int
        """

        self._state = state

    @property
    def sync_status(self):
        """Gets the sync_status of this CellularConnectivityForBs.  # noqa: E501

        Synchronisation status of a cellular connectivity configuration 0 -> OK (the conf is synchronized) 1 -> TO_BE_SENT (the conf has to be synchronized) 2 -> SENT (the conf is currently send to the base station)   # noqa: E501

        :return: The sync_status of this CellularConnectivityForBs.  # noqa: E501
        :rtype: int
        """
        return self._sync_status

    @sync_status.setter
    def sync_status(self, sync_status):
        """Sets the sync_status of this CellularConnectivityForBs.

        Synchronisation status of a cellular connectivity configuration 0 -> OK (the conf is synchronized) 1 -> TO_BE_SENT (the conf has to be synchronized) 2 -> SENT (the conf is currently send to the base station)   # noqa: E501

        :param sync_status: The sync_status of this CellularConnectivityForBs.  # noqa: E501
        :type: int
        """

        self._sync_status = sync_status

    @property
    def last_switch_error_status(self):
        """Gets the last_switch_error_status of this CellularConnectivityForBs.  # noqa: E501

        Error status returned after a connectivity config switch 0 -> SUCCESS 1 -> BAD_GSM_PIN 2 -> TOO_MANY_PIN_TRIES 3 -> VPN_ESTABLISHMENT_IMPOSSIBLE 4 -> NETWORK_REJECTED 5 -> UNKNOWN   # noqa: E501

        :return: The last_switch_error_status of this CellularConnectivityForBs.  # noqa: E501
        :rtype: int
        """
        return self._last_switch_error_status

    @last_switch_error_status.setter
    def last_switch_error_status(self, last_switch_error_status):
        """Sets the last_switch_error_status of this CellularConnectivityForBs.

        Error status returned after a connectivity config switch 0 -> SUCCESS 1 -> BAD_GSM_PIN 2 -> TOO_MANY_PIN_TRIES 3 -> VPN_ESTABLISHMENT_IMPOSSIBLE 4 -> NETWORK_REJECTED 5 -> UNKNOWN   # noqa: E501

        :param last_switch_error_status: The last_switch_error_status of this CellularConnectivityForBs.  # noqa: E501
        :type: int
        """

        self._last_switch_error_status = last_switch_error_status

    @property
    def last_setconf_error_status(self):
        """Gets the last_setconf_error_status of this CellularConnectivityForBs.  # noqa: E501

        Error status returned after a connectivity config creation/edition 0 -> SUCCESS 1 -> BAD_FORMAT 2 -> EXISTING_CONFIG 3 -> TOO_MANY_CONFIG 4 -> CONFIG_ID_CONFLICT 5 -> UNKNOWN   # noqa: E501

        :return: The last_setconf_error_status of this CellularConnectivityForBs.  # noqa: E501
        :rtype: int
        """
        return self._last_setconf_error_status

    @last_setconf_error_status.setter
    def last_setconf_error_status(self, last_setconf_error_status):
        """Sets the last_setconf_error_status of this CellularConnectivityForBs.

        Error status returned after a connectivity config creation/edition 0 -> SUCCESS 1 -> BAD_FORMAT 2 -> EXISTING_CONFIG 3 -> TOO_MANY_CONFIG 4 -> CONFIG_ID_CONFLICT 5 -> UNKNOWN   # noqa: E501

        :param last_setconf_error_status: The last_setconf_error_status of this CellularConnectivityForBs.  # noqa: E501
        :type: int
        """

        self._last_setconf_error_status = last_setconf_error_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CellularConnectivityForBs, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CellularConnectivityForBs):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
