# coding: utf-8

"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class EthernetConnectivityBase(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'type': 'int',
        'ip': 'str',
        'mask': 'str',
        'dns1': 'str',
        'dns2': 'str',
        'gateway': 'str',
        'mtu': 'int'
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'ip': 'ip',
        'mask': 'mask',
        'dns1': 'dns1',
        'dns2': 'dns2',
        'gateway': 'gateway',
        'mtu': 'mtu'
    }

    def __init__(self, name=None, type=None, ip=None, mask=None, dns1=None, dns2=None, gateway=None, mtu=None):  # noqa: E501
        """EthernetConnectivityBase - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._type = None
        self._ip = None
        self._mask = None
        self._dns1 = None
        self._dns2 = None
        self._gateway = None
        self._mtu = None
        self.discriminator = None
        self.name = name
        self.type = type
        if ip is not None:
            self.ip = ip
        if mask is not None:
            self.mask = mask
        if dns1 is not None:
            self.dns1 = dns1
        if dns2 is not None:
            self.dns2 = dns2
        if gateway is not None:
            self.gateway = gateway
        if mtu is not None:
            self.mtu = mtu

    @property
    def name(self):
        """Gets the name of this EthernetConnectivityBase.  # noqa: E501

        the name of the configuration  # noqa: E501

        :return: The name of this EthernetConnectivityBase.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EthernetConnectivityBase.

        the name of the configuration  # noqa: E501

        :param name: The name of this EthernetConnectivityBase.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def type(self):
        """Gets the type of this EthernetConnectivityBase.  # noqa: E501

        Token's type of an ethernet connectivity configuration 1 -> STATIC 2 -> PARTLY_DYNAMIC   # noqa: E501

        :return: The type of this EthernetConnectivityBase.  # noqa: E501
        :rtype: int
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this EthernetConnectivityBase.

        Token's type of an ethernet connectivity configuration 1 -> STATIC 2 -> PARTLY_DYNAMIC   # noqa: E501

        :param type: The type of this EthernetConnectivityBase.  # noqa: E501
        :type: int
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def ip(self):
        """Gets the ip of this EthernetConnectivityBase.  # noqa: E501

        IP address of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :return: The ip of this EthernetConnectivityBase.  # noqa: E501
        :rtype: str
        """
        return self._ip

    @ip.setter
    def ip(self, ip):
        """Sets the ip of this EthernetConnectivityBase.

        IP address of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :param ip: The ip of this EthernetConnectivityBase.  # noqa: E501
        :type: str
        """

        self._ip = ip

    @property
    def mask(self):
        """Gets the mask of this EthernetConnectivityBase.  # noqa: E501

        Subnet mask of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :return: The mask of this EthernetConnectivityBase.  # noqa: E501
        :rtype: str
        """
        return self._mask

    @mask.setter
    def mask(self, mask):
        """Sets the mask of this EthernetConnectivityBase.

        Subnet mask of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :param mask: The mask of this EthernetConnectivityBase.  # noqa: E501
        :type: str
        """

        self._mask = mask

    @property
    def dns1(self):
        """Gets the dns1 of this EthernetConnectivityBase.  # noqa: E501

        DNS n°1 of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :return: The dns1 of this EthernetConnectivityBase.  # noqa: E501
        :rtype: str
        """
        return self._dns1

    @dns1.setter
    def dns1(self, dns1):
        """Sets the dns1 of this EthernetConnectivityBase.

        DNS n°1 of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :param dns1: The dns1 of this EthernetConnectivityBase.  # noqa: E501
        :type: str
        """

        self._dns1 = dns1

    @property
    def dns2(self):
        """Gets the dns2 of this EthernetConnectivityBase.  # noqa: E501

        DNS n°2 of the ethernet connectivity, only applicable if the type is STATIC. This field can be unset when updating.  # noqa: E501

        :return: The dns2 of this EthernetConnectivityBase.  # noqa: E501
        :rtype: str
        """
        return self._dns2

    @dns2.setter
    def dns2(self, dns2):
        """Sets the dns2 of this EthernetConnectivityBase.

        DNS n°2 of the ethernet connectivity, only applicable if the type is STATIC. This field can be unset when updating.  # noqa: E501

        :param dns2: The dns2 of this EthernetConnectivityBase.  # noqa: E501
        :type: str
        """

        self._dns2 = dns2

    @property
    def gateway(self):
        """Gets the gateway of this EthernetConnectivityBase.  # noqa: E501

        Gateway of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :return: The gateway of this EthernetConnectivityBase.  # noqa: E501
        :rtype: str
        """
        return self._gateway

    @gateway.setter
    def gateway(self, gateway):
        """Sets the gateway of this EthernetConnectivityBase.

        Gateway of the ethernet connectivity, required if the type is STATIC  # noqa: E501

        :param gateway: The gateway of this EthernetConnectivityBase.  # noqa: E501
        :type: str
        """

        self._gateway = gateway

    @property
    def mtu(self):
        """Gets the mtu of this EthernetConnectivityBase.  # noqa: E501

        MTU of the ethernet connectivity, required if the type is PARTLY_DYNAMIC. This field can be unset when updating.  # noqa: E501

        :return: The mtu of this EthernetConnectivityBase.  # noqa: E501
        :rtype: int
        """
        return self._mtu

    @mtu.setter
    def mtu(self, mtu):
        """Sets the mtu of this EthernetConnectivityBase.

        MTU of the ethernet connectivity, required if the type is PARTLY_DYNAMIC. This field can be unset when updating.  # noqa: E501

        :param mtu: The mtu of this EthernetConnectivityBase.  # noqa: E501
        :type: int
        """

        self._mtu = mtu

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EthernetConnectivityBase, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EthernetConnectivityBase):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
