# coding: utf-8

"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from sigfox_api_client.models.base_site import BaseSite


class Site(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'host_id': 'MinHost',
        'maintenance_id': 'MinMaintenance',
        'group_id': 'MinGroup',
        'basestation_count': 'int',
        'primary_internet_subscription': 'InternetSubscription',
        'candidate_external_id': 'int',
        'location': 'list[object]',
        'creation_time': 'int',
        'created_by': 'str',
        'last_edited_time': 'int',
        'last_edited_by': 'str'
    }
    if hasattr(BaseSite, "swagger_types"):
        swagger_types.update(BaseSite.swagger_types)

    attribute_map = {
        'id': 'id',
        'host_id': 'hostId',
        'maintenance_id': 'maintenanceId',
        'group_id': 'groupId',
        'basestation_count': 'basestationCount',
        'primary_internet_subscription': 'primaryInternetSubscription',
        'candidate_external_id': 'candidateExternalId',
        'location': 'location',
        'creation_time': 'creationTime',
        'created_by': 'createdBy',
        'last_edited_time': 'lastEditedTime',
        'last_edited_by': 'lastEditedBy'
    }
    if hasattr(BaseSite, "attribute_map"):
        attribute_map.update(BaseSite.attribute_map)

    def __init__(self, id=None, host_id=None, maintenance_id=None, group_id=None, basestation_count=None, primary_internet_subscription=None, candidate_external_id=None, location=None, creation_time=None, created_by=None, last_edited_time=None, last_edited_by=None, *args, **kwargs):  # noqa: E501
        """Site - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._host_id = None
        self._maintenance_id = None
        self._group_id = None
        self._basestation_count = None
        self._primary_internet_subscription = None
        self._candidate_external_id = None
        self._location = None
        self._creation_time = None
        self._created_by = None
        self._last_edited_time = None
        self._last_edited_by = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if host_id is not None:
            self.host_id = host_id
        if maintenance_id is not None:
            self.maintenance_id = maintenance_id
        if group_id is not None:
            self.group_id = group_id
        if basestation_count is not None:
            self.basestation_count = basestation_count
        if primary_internet_subscription is not None:
            self.primary_internet_subscription = primary_internet_subscription
        if candidate_external_id is not None:
            self.candidate_external_id = candidate_external_id
        if location is not None:
            self.location = location
        if creation_time is not None:
            self.creation_time = creation_time
        if created_by is not None:
            self.created_by = created_by
        if last_edited_time is not None:
            self.last_edited_time = last_edited_time
        if last_edited_by is not None:
            self.last_edited_by = last_edited_by
        BaseSite.__init__(self, *args, **kwargs)

    @property
    def id(self):
        """Gets the id of this Site.  # noqa: E501

        The site's identifier  # noqa: E501

        :return: The id of this Site.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Site.

        The site's identifier  # noqa: E501

        :param id: The id of this Site.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def host_id(self):
        """Gets the host_id of this Site.  # noqa: E501


        :return: The host_id of this Site.  # noqa: E501
        :rtype: MinHost
        """
        return self._host_id

    @host_id.setter
    def host_id(self, host_id):
        """Sets the host_id of this Site.


        :param host_id: The host_id of this Site.  # noqa: E501
        :type: MinHost
        """

        self._host_id = host_id

    @property
    def maintenance_id(self):
        """Gets the maintenance_id of this Site.  # noqa: E501


        :return: The maintenance_id of this Site.  # noqa: E501
        :rtype: MinMaintenance
        """
        return self._maintenance_id

    @maintenance_id.setter
    def maintenance_id(self, maintenance_id):
        """Sets the maintenance_id of this Site.


        :param maintenance_id: The maintenance_id of this Site.  # noqa: E501
        :type: MinMaintenance
        """

        self._maintenance_id = maintenance_id

    @property
    def group_id(self):
        """Gets the group_id of this Site.  # noqa: E501


        :return: The group_id of this Site.  # noqa: E501
        :rtype: MinGroup
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """Sets the group_id of this Site.


        :param group_id: The group_id of this Site.  # noqa: E501
        :type: MinGroup
        """

        self._group_id = group_id

    @property
    def basestation_count(self):
        """Gets the basestation_count of this Site.  # noqa: E501

        the number of base station installed on this site  # noqa: E501

        :return: The basestation_count of this Site.  # noqa: E501
        :rtype: int
        """
        return self._basestation_count

    @basestation_count.setter
    def basestation_count(self, basestation_count):
        """Sets the basestation_count of this Site.

        the number of base station installed on this site  # noqa: E501

        :param basestation_count: The basestation_count of this Site.  # noqa: E501
        :type: int
        """

        self._basestation_count = basestation_count

    @property
    def primary_internet_subscription(self):
        """Gets the primary_internet_subscription of this Site.  # noqa: E501


        :return: The primary_internet_subscription of this Site.  # noqa: E501
        :rtype: InternetSubscription
        """
        return self._primary_internet_subscription

    @primary_internet_subscription.setter
    def primary_internet_subscription(self, primary_internet_subscription):
        """Sets the primary_internet_subscription of this Site.


        :param primary_internet_subscription: The primary_internet_subscription of this Site.  # noqa: E501
        :type: InternetSubscription
        """

        self._primary_internet_subscription = primary_internet_subscription

    @property
    def candidate_external_id(self):
        """Gets the candidate_external_id of this Site.  # noqa: E501

        the external identifier of the site as a candidate  # noqa: E501

        :return: The candidate_external_id of this Site.  # noqa: E501
        :rtype: int
        """
        return self._candidate_external_id

    @candidate_external_id.setter
    def candidate_external_id(self, candidate_external_id):
        """Sets the candidate_external_id of this Site.

        the external identifier of the site as a candidate  # noqa: E501

        :param candidate_external_id: The candidate_external_id of this Site.  # noqa: E501
        :type: int
        """

        self._candidate_external_id = candidate_external_id

    @property
    def location(self):
        """Gets the location of this Site.  # noqa: E501

        ISO 3166-1 UN M.49 country code of the site location. The first code is the country (region and department available for some countries).  # noqa: E501

        :return: The location of this Site.  # noqa: E501
        :rtype: list[object]
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Site.

        ISO 3166-1 UN M.49 country code of the site location. The first code is the country (region and department available for some countries).  # noqa: E501

        :param location: The location of this Site.  # noqa: E501
        :type: list[object]
        """

        self._location = location

    @property
    def creation_time(self):
        """Gets the creation_time of this Site.  # noqa: E501

        Date of the creation of this site (in milliseconds)  # noqa: E501

        :return: The creation_time of this Site.  # noqa: E501
        :rtype: int
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this Site.

        Date of the creation of this site (in milliseconds)  # noqa: E501

        :param creation_time: The creation_time of this Site.  # noqa: E501
        :type: int
        """

        self._creation_time = creation_time

    @property
    def created_by(self):
        """Gets the created_by of this Site.  # noqa: E501

        Identifier of the user who created this site  # noqa: E501

        :return: The created_by of this Site.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this Site.

        Identifier of the user who created this site  # noqa: E501

        :param created_by: The created_by of this Site.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def last_edited_time(self):
        """Gets the last_edited_time of this Site.  # noqa: E501

        Date of the last edition of this site (in milliseconds)  # noqa: E501

        :return: The last_edited_time of this Site.  # noqa: E501
        :rtype: int
        """
        return self._last_edited_time

    @last_edited_time.setter
    def last_edited_time(self, last_edited_time):
        """Sets the last_edited_time of this Site.

        Date of the last edition of this site (in milliseconds)  # noqa: E501

        :param last_edited_time: The last_edited_time of this Site.  # noqa: E501
        :type: int
        """

        self._last_edited_time = last_edited_time

    @property
    def last_edited_by(self):
        """Gets the last_edited_by of this Site.  # noqa: E501

        Identifier of the user who last edited this site  # noqa: E501

        :return: The last_edited_by of this Site.  # noqa: E501
        :rtype: str
        """
        return self._last_edited_by

    @last_edited_by.setter
    def last_edited_by(self, last_edited_by):
        """Sets the last_edited_by of this Site.

        Identifier of the user who last edited this site  # noqa: E501

        :param last_edited_by: The last_edited_by of this Site.  # noqa: E501
        :type: str
        """

        self._last_edited_by = last_edited_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Site, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Site):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
