# coding: utf-8

"""
    Sigfox API

     # API overview Sigfox API is used to integrate with the Sigfox platform.  The API uses the HTTP protocol, following the REST principles (POST, GET, DELETE, PUT requests). The API endpoints accept and return data in the JSON format, with the corresponding \"application/json\" content type header.  The Sigfox API access differs for every API User based on their profile. If you already have a Sigfox account, you can retrieve the API Documentation customized for your API User directly in json or yaml format. The “how to” procedure is detailed in the [API Documentation](https://support.sigfox.com/docs/api-documentation) article.  The PUT request is the only request used to edit an existing entity. You don't need to specify each value. If a property is not present in the request, it won't be processed and updated. To remove an optional property, it must be filled in the request with the explicit value NULL. If a property has no value, it won't appear in the result of a GET request.  # Authentication and security Sigfox API is only accessible using HTTPS, and all API endpoints require authentication credentials (API user login and password). An API User is associated to a group with given profiles. You can view and manage your API User in the [Sigfox Portal](https://backend.sigfox.com/auth/login).  If you need an API User, follow the [API credential creation](https://support.sigfox.com/docs/api-credential-creation) procedure.  Your API User must remain private. Should the API credentials be compromised, new ones can be generated at any moment, invalidating the previous ones. CORS and JSONP are intentionally unsupported. CORS and JSONP JavaScript techniques tends to expose your credentials to your users. If you really need to call Sigfox API from JavaScript in the browser, you must set a reverse proxy on your website. Be careful not to use proxy for all requests to Sigfox OSS but to only select the relevant ones.  <!-- ReDoc-Inject: <security-definitions> -->  # Usage limits All Sigfox API endpoints are using the same underlying technology that powers the core Sigfox Platform. For Cloud efficiency and security reasons, Sigfox is moving a step forward on API rate limiting, by setting upper bounds for some API endpoints. Please note that a new HTTP response will be returned in case of rate exceeded : “HTTP 429: too many requests”.  For more information check [API Rate limiting](https://support.sigfox.com/docs/api-rate-limiting) policy. Sigfox reserves the right to modify these limits without notice.  # Versioning  Sigfox API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vX\", where X is the version number. For example: v2/device.  All requests must include the version suffix in the endpoint URL.  Any new backwards-incompatible change will be released in a new version.   Read the [API versioning management](https://storage.sbg1.cloud.ovh.net/v1/AUTH_669d7dfced0b44518cb186841d7cbd75/prod_docs/55746591-API_Versioning_management.pdf) to learn more about it.  # Paging  Some API requests will return a list of data. If the list is longer than the set limit, the items will be retrieved via multiple requests. The paging section in the response will specify a URL for the next request.  Keep in mind rate limiting policy to manage your requests.  You can use the limit parameter to limit the number of items to be returned, between 1 and 100 (default). The offset parameter is used to specify a number of items to skip.  # Errors  Sigfox API uses conventional HTTP response codes to indicate the success or failure of an API request.  Codes in the 2xx range indicate success.  Codes in the 4xx range indicate an error that failed given the information provided (e.g. a required parameter missing, a resource was not found, etc.). Often the response will also include a message explaining the error.  Codes in the 5xx range indicate an error with servers.   For more information please refer to the [Response code article](https://support.sigfox.com/docs/api-response-code-references).   # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class Token(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'state': 'int',
        'detail_message': 'str',
        'end': 'int',
        'free_messages': 'int',
        'free_messages_sent': 'int'
    }

    attribute_map = {
        'state': 'state',
        'detail_message': 'detailMessage',
        'end': 'end',
        'free_messages': 'freeMessages',
        'free_messages_sent': 'freeMessagesSent'
    }

    def __init__(self, state=None, detail_message=None, end=None, free_messages=None, free_messages_sent=None):  # noqa: E501
        """Token - a model defined in Swagger"""  # noqa: E501
        self._state = None
        self._detail_message = None
        self._end = None
        self._free_messages = None
        self._free_messages_sent = None
        self.discriminator = None
        if state is not None:
            self.state = state
        if detail_message is not None:
            self.detail_message = detail_message
        if end is not None:
            self.end = end
        if free_messages is not None:
            self.free_messages = free_messages
        if free_messages_sent is not None:
            self.free_messages_sent = free_messages_sent

    @property
    def state(self):
        """Gets the state of this Token.  # noqa: E501

        - 0 -> OK - 1 -> OFF_CONTRACT - 2 -> NA_FOR_API - 3 -> INVALID_TOKEN   # noqa: E501

        :return: The state of this Token.  # noqa: E501
        :rtype: int
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this Token.

        - 0 -> OK - 1 -> OFF_CONTRACT - 2 -> NA_FOR_API - 3 -> INVALID_TOKEN   # noqa: E501

        :param state: The state of this Token.  # noqa: E501
        :type: int
        """

        self._state = state

    @property
    def detail_message(self):
        """Gets the detail_message of this Token.  # noqa: E501

        Token state description - Valid - Off Contract - Not applicable for API - Invalid   # noqa: E501

        :return: The detail_message of this Token.  # noqa: E501
        :rtype: str
        """
        return self._detail_message

    @detail_message.setter
    def detail_message(self, detail_message):
        """Sets the detail_message of this Token.

        Token state description - Valid - Off Contract - Not applicable for API - Invalid   # noqa: E501

        :param detail_message: The detail_message of this Token.  # noqa: E501
        :type: str
        """

        self._detail_message = detail_message

    @property
    def end(self):
        """Gets the end of this Token.  # noqa: E501

        The device's communication end time (in milliseconds since the Unix Epoch)  # noqa: E501

        :return: The end of this Token.  # noqa: E501
        :rtype: int
        """
        return self._end

    @end.setter
    def end(self, end):
        """Sets the end of this Token.

        The device's communication end time (in milliseconds since the Unix Epoch)  # noqa: E501

        :param end: The end of this Token.  # noqa: E501
        :type: int
        """

        self._end = end

    @property
    def free_messages(self):
        """Gets the free_messages of this Token.  # noqa: E501

        The number of free messages left for this token  # noqa: E501

        :return: The free_messages of this Token.  # noqa: E501
        :rtype: int
        """
        return self._free_messages

    @free_messages.setter
    def free_messages(self, free_messages):
        """Sets the free_messages of this Token.

        The number of free messages left for this token  # noqa: E501

        :param free_messages: The free_messages of this Token.  # noqa: E501
        :type: int
        """

        self._free_messages = free_messages

    @property
    def free_messages_sent(self):
        """Gets the free_messages_sent of this Token.  # noqa: E501

        The number of free messages already sent for this token  # noqa: E501

        :return: The free_messages_sent of this Token.  # noqa: E501
        :rtype: int
        """
        return self._free_messages_sent

    @free_messages_sent.setter
    def free_messages_sent(self, free_messages_sent):
        """Sets the free_messages_sent of this Token.

        The number of free messages already sent for this token  # noqa: E501

        :param free_messages_sent: The free_messages_sent of this Token.  # noqa: E501
        :type: int
        """

        self._free_messages_sent = free_messages_sent

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Token, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Token):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
